using System.Collections.Generic;
using System.Dynamic;
using System.Linq;

namespace eea_e1a_get
{
    public class CSV
    {
        private Dictionary<object, Dictionary<string, object>> _rows;

        public CSV() 
        {
            _rows = new Dictionary<object, Dictionary<string, object>>();
        }

        public void AddRow(object key, Dictionary<string, object> values)
        {            
            _rows.Add(key, values);
        }

        public void AddCell(object rowKey, string key, object value)
        {
            if(!_rows.ContainsKey(rowKey))
            {
                _rows.Add(rowKey, new Dictionary<string, object>());
            }  
            if(!_rows[rowKey].ContainsKey(key))
            {
                _rows[rowKey].Add(key, null);
            }
             _rows[rowKey][key] = value;
        }

        public void EditCell(object rowKey, string key, object value)
        {
            if(_rows.ContainsKey(rowKey))
            {
                if(_rows[rowKey].ContainsKey(key))
                {
                    _rows[rowKey][key] = value;
                }
            }               
        }

        public dynamic ToObject()
        {
            return _rows.Values.Select(p=> DictionaryToObject(p)).ToList();
        }

        private static dynamic DictionaryToObject(Dictionary<string, object> dict)
        {
            IDictionary<string, object> eo = new ExpandoObject() as IDictionary<string, object>;
            foreach (KeyValuePair<string, object> kvp in dict)
            {
                eo.Add(kvp);
            }
            return eo;
        }
    }
}